<template>
<div class="parent">
  <div class="main" v-if="!isHidden">
    <div class="topbar" v-if="!isHidden">
      <div id="icon_container">
        <img src="../assets/img/oval.png" id="avatar" alt="Girl in a jacket">
        <div id="icon_status">
          &nbsp;
        </div>
      </div>
      <div id="topbar_text_container">
        <div id="topbar_name_container">
          <p id="topbar_name">Poliklinika Sinteza</p>
        </div>
        <div id="topbar_desc_container">
          <p id="topbar_desc">We are here to assist you and answer any questions</p>
        </div>
      </div>
      <div id="topbar_close_container" @click="isHidden = true">
        <div id="close_img_container">
          <img src="../assets/img/new-copy.png" id="close" alt="close">
        </div>
      </div>
    </div>
    <div class="midbar" id="scroll" v-if="!isHidden">
      <div :class="(message.from == 'user') ? 'text_msg_left' : 'text_msg_right'"
        v-for="(message,i) in messages" :key="i">
        <div
          :class="(message.from == 'user') ? 'text_msg_left_mcontainer' : 'text_msg_right_mcontainer'">
          <div :class="(message.from == 'user') ? 'text_msg_left_text' : 'text_msg_right_text'">
            <div :class="(message.from == 'user') ? 'left_text_container' : 'right_text_container'">
              <p :id="(message.from == 'user') ? 'left_text' : 'right_text'">
                {{message.msg}}
              </p>
            </div>
          </div>
          <div :class="(message.from == 'user') ? 'left_text_date' : 'right_text_date'">
            <p :id="(message.from == 'user') ? 'left_date' : 'right_date'">
              {{message.formatedTime}}
            </p>
          </div>
        </div>
      </div>
        <div v-if="chatEnded" class="text_msg_left">

          <div class="text_msg_left_mcontainer">
          <div class="text_msg_left_text">
            <div class="left_text_container">
              <p id="left_text">
                Chat ended, thank you
              </p>
            </div>
          </div>
          <div class="left_text_date">
            <p id="left_date">
              {{message.formatedTime}}
            </p>
          </div>
        </div>
        </div>
    </div>
    <div class="botbar" v-if="!isHidden && !chatEnded">
      <form class="main_input_container" @submit.prevent>
        <div class="actual_input">
          <input type="text" placeholder="type your message" id="input" v-model="msg"
            @keyup.enter.prevent="sendmsg">
        </div>
        <div class="send" @click="sendmsg">
          <img src="../assets/img/send@2x.svg" id="send" alt="send" height="20px" width="20px">
        </div>
      </form>
    </div>
  </div>

    <div class="small_container" v-if="isHidden" @click="isHidden = false">
      <div class="small_container_image">
        <img src="../assets/img/oval@2x.png" id="small_img" alt="close">
      </div>
      <div class="small_container_text">
        <p id="text1">Any Questions?</p>
        <p id="text2">Contact us and talk to our employees</p>
        <p id="text3" @click="isHidden = false">Start Chat</p>
      </div>
      <div id="small_container_close">
        <div id="small_container_img_container">
          <img src="../assets/img/new-copy.png" id="smallclose" alt="close">
        </div>
      </div>
    </div>
    </div>
</template>

<script>

import io from 'socket.io-client';
import moment from 'moment';
import { v4 as uuid } from 'uuid';
import axios from 'axios';

export default {
    name: 'popupchat',
    data()
    {
        return {
            msg: '',
            socket: null,
            messages: [],
            isHidden: true,
            chatEnded: false,
        };
    },
    async created()
    {
        const me = this;

        try
        {
            if (me.getCookie('uuid') || me.getCookie('uuid') === '0')
            {
                const response = await axios.get(`https://sinteza-chat.herokuapp.com/fetchuserchat?socketId=${me.getCookie('uuid')}`);

                if (response.data)
                {
                    me.isHidden = false;
                    me.messages = response.data.messages;
                    if (response.data.status === 'done')
                    {
                        me.chatEnded = true;
                    }
                }
            }
        }
        catch (error)
        {
            console.error(error);
        }
    },
    methods: {

        sendmsg()
        {
            const me = this;

            if (me.socket === null)
            {
                me.socket = io('https://sinteza-chat.herokuapp.com');

                me.socket.on('adminreply', (data) =>
                {
                    data.formatedTime = moment.utc(data.datetime).local().format('HH:mm:ss');
                    me.messages.push(data);
                });

                me.socket.on('endchat', () =>
                {
                    me.chatEnded = true;
                });
            }

            let uuidin = null;

            if (!me.getCookie('uuid') || me.getCookie('uuid') === '0')
            {
                uuidin = uuid();
                me.setCookie('uuid', uuidin, 7);
            }
            else
            {
                uuidin = me.getCookie('uuid');
            }

            const message = {
                msg: me.msg,
                from: 'user',
                formatedTime: moment().format('HH:mm:ss'),
                socketId: uuidin,
            };

            me.socket.emit('message', message);

            me.messages.push(message);
            me.msg = '';
        },
        setCookie(name, value, days)
        {
            let expires = '';
            if (days)
            {
                const date = new Date();
                date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
                expires = `; expires=${date.toUTCString()}`;
            }
            document.cookie = `${name}=${value || ''}${expires}; path=/`;
        },
        getCookie(name)
        {
            const nameEQ = `${name}=`;
            const ca = document.cookie.split(';');
            for (let i = 0; i < ca.length; i += 1)
            {
                let c = ca[i];
                while (c.charAt(0) === ' ')
                {
                    c = c.substring(1, c.length);
                }
                if (c.indexOf(nameEQ) === 0)
                {
                    return c.substring(nameEQ.length, c.length);
                }
            }
            return null;
        },
    },

    watch: {
        messages()
        {
            const me = this;
            me.$nextTick(() =>
            {
                const element = document.getElementById('scroll');
                element.scrollTop = element.scrollHeight;
            });
        },
        chatEnded(val)
        {
            const me = this;
            if (val === true)
            {
                me.setCookie('uuid', '0', 7);
            }
        },
    },

};
</script>
